<?php
namespace Teknisa\CADFIS\Controllers\Import;

use Teknisa\Libs\Util\XLS\FileReader;
use PHPExcel_Cell;

class XlsImportFile extends ImportFile 
{
    private $spreadsheet;
    private $columnNames;
    
    protected function getContent(): void
    {
        if (!$this->columnNames)
            throw new \Exception("Atributo columnNames deve ser definido");
            
        $worksheet = $this->fileContent->getActiveSheet();
        $this->spreadsheet = FileReader::readWorksheetTable($worksheet, $this->columnNames);
    }

    protected function formatContent(): void
    {
        $this->content = $this->spreadsheet->getRows();
        $i = 2;
        foreach ($this->content as &$row) {
            $row = $row['content'];
            $row["ROWNUM"] = $i;

            $i++;
        }
    }
    
    public function getColumnNames()
    {
        return $this->columnNames;
    }
    
    public function setColumnNames($columnNames)
    {
        $this->columnNames = $columnNames;
    }
}