<?php

namespace Teknisa\CADFIS\Services;

use Teknisa\CADFIS\Factories\AgrupInscEstaFactory;

class AgrupInscEstaService {
  
  protected $AgrupInscEstaFactory; 
  
  public function __construct(AgrupInscEstaFactory $AgrupInscEstaFactory) {
    $this->AgrupInscEstaFactory = $AgrupInscEstaFactory;
  }
  
  public function saveAgrupInscEsta($row) {
    try{
      $arrayCdinscesta = $row['CDINSCESTA'];
      $nrorg = $row['NRORG'];
      $operador = $row['CDOPERADOR']; 
      $i = 0;
      foreach ($arrayCdinscesta as $cdinscesta){
          $selectInscEsta = $this->AgrupInscEstaFactory->selectInscEst($cdinscesta, $row['CDGRUPINSCESTA']);
          if(empty($selectInscEsta)){
            $params = array(
               "CDGRUPINSCESTA" => $row['CDGRUPINSCESTA'],
               "CDINSCESTA" => $cdinscesta,
               "NRORG" => $nrorg,
               "IDATIVO" => 'S',
               "DTINCLUSAO" => $row['DATA'],
               "DTULTATU" => $row['DATA'],
               "NRORGINCLUSAO"  => $nrorg,
               "CDOPERINCLUSAO" => $operador,
               "NRORGULTATU"  => $nrorg,
               "CDOPERULTATU" => $operador
            );
            $i++;
            
            $this->AgrupInscEstaFactory->saveAgrupInscEsta($params);
          }
      }
      
    } catch(\Exception $e) {
        throw $e;
    }
    
  }
  
  public function cadastroAutomaticoEmpresa($row) {
    try{
      
      $arrayTipoContPag = $row["CDTPCTPAGAR"];
      
      foreach($arrayTipoContPag as $tipoContPag){
          $rowToSave = $row;
          $rowToSave['CDTPCTPAGAR'] = $tipoContPag;
          if($row['IDOPERACAO'] === 'I'){
            $this->saveEmpresa($row);
          } 
          else if($row['IDOPERACAO'] === 'S'){
            $this->AgrupInscEstaFactory->deleteEmpresa($rowToSave['CDTPCTPAGAR']);
            
            $this->saveEmpresa($row);
          }
          
      }
      
    } catch(\Exception $e) {
        throw $e;
    }
    
  }
  
}
